
import java.awt.AWTException;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferStrategy;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.event.MouseInputListener;

public class MainWin extends JFrame implements MouseMotionListener, MouseInputListener{

	
	private Image gullg = null;
	private Image gulld = null;
	private Image gull = null;
	private Image fond = null;
	private Image nuage = null;
	private Image man = null;
	private Image manGood = null;
	private Image manc = null;
	private Image chiure = null;
	private Image hit = null;
	private boolean chiureAlive = false;
	private boolean hited = false;
	public boolean ready = true;
	private int x = 0,y=0,tx=0,xman = 0, inc = 1, v=4,xc = 0, yc = 0,score = 0, time = 3000;
	private TimeLine nuagex= new TimeLine(this);
	
	private Robot rob = null;
	private BufferStrategy strategy; 
	private Graphics buffer;

	public static String url;
	
	public static void main(String[] args) throws AWTException, InterruptedException {
		if(args.length!=1)
		{
			System.err.println("erreur parametres [ip_serveur:port]");
			System.exit(0);
		}
		url = args[0];
		//MainWin win = new MainWin();
		new MainWin();
	
	}
	private MainWin() throws AWTException, InterruptedException{
		super("Le jeu de la mouette!");
		
		Toolkit tk = Toolkit.getDefaultToolkit();
		gullg = tk.getImage(getClass().getResource("/pic/gouelg.PNG"));
		gulld = tk.getImage(getClass().getResource("/pic/gouelD.PNG"));
		manGood = tk.getImage(getClass().getResource("/pic/superA.PNG"));
		manc = tk.getImage(getClass().getResource("/pic/superAHIT.PNG"));
		chiure = tk.getImage(getClass().getResource("/pic/fall.PNG"));
		hit = tk.getImage(getClass().getResource("/pic/hit.PNG"));
		fond = tk.getImage(getClass().getResource("/pic/plage.PNG"));
		nuage = tk.getImage(getClass().getResource("/pic/nuage.PNG"));
		Image img = tk.getImage(getClass().getResource("/pic/cur.png"));
		Cursor cur = tk.createCustomCursor(img, new Point(1, 1), "cur");
		
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setPreferredSize(new Dimension(640,480));
		this.setSize(new Dimension(640,480));
		this.setResizable(false);
		this.setVisible(true);
	
		this.setIgnoreRepaint( true );  
		this.createBufferStrategy( 2 ); 
		strategy = this.getBufferStrategy();
		
		gull = gulld;
		man = manGood;
		rob = new Robot();
		nuagex.start();
		this.addMouseMotionListener(this);
		this.addMouseListener(this);
		this.setCursor(cur);
	}
	private static final long serialVersionUID = 1L;

	@Override
	public void mouseDragged(MouseEvent arg0) {
		mouseClicked(arg0);
	}

	@Override
	public void mouseMoved(MouseEvent arg0) {
		tx=x;
		x= (int)arg0.getPoint().getX();
		y= (int)arg0.getPoint().getY();
		if(x<tx)
			gull = gullg;
		if(x>tx)
			gull = gulld;
		if(y>200)
			rob.mouseMove(this.getX()+x, this.getY()+200);
	}
	

	public synchronized void render() throws MalformedURLException, RemoteException, NotBoundException{
		buffer = strategy.getDrawGraphics();
		buffer.drawImage(fond, 0, 0, null);
		buffer.setColor(Color.black);
		buffer.drawString("score : "+score+" temps restant : "+time/100, 10, 41);
		buffer.setColor(Color.white);
		buffer.drawString("score : "+score, 9, 40);
		
		//dessin des nuages
		buffer.drawImage(nuage,nuagex.getx(),36,null);
		//dessin de la chiure
		if(chiureAlive){
			buffer.drawImage(chiure, xc-32, yc-32, null);
			yc+=3;
			if (yc >416)
			{
				if(xman<xc+28 && xman >xc-28 && chiureAlive){
				man = manc;
				hited = true;
				score+=100;
				}
				chiureAlive = false;
				score-=10;
			}
			}
		
		if (!hited && yc >416)
			buffer.drawImage(hit, xc-32, yc-32, null);
		//dessin du gas
		if(xman>600)inc = -1;
		if(xman<34)inc = 1;
		xman = xman + v*inc;
		buffer.drawImage(man, xman-32, 414, null);
		//dessin de la mouette
		buffer.drawImage(gull, x-32, y-32, null);
		buffer.dispose();
		strategy.show();
		
		time--;
		if(time<0){
			nuagex.stopme();
			try{
			new ScoreDlg(this,score);
			}
			catch(Exception e)
			{
				JOptionPane.showMessageDialog(this,"score (serveur hors ligne) : "+score,"score final",0);
			}
			this.setVisible(false);
			

			System.exit(0);
		}
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {
		if(!chiureAlive)
		{
		xc = x;
		yc = y;
		man = manGood;
		hited = false;
		chiureAlive = true;	
		}
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	public void wind(int vent ){
		x+=vent;	
		if(x<10)x=10;
		if(x>630)x=630;
		//rob.mouseMove(this.getX()+x, this.getY()+y);
		}

}
