import java.awt.AWTException;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.ArrayList;


public class ScViewer {

	public static void main(String[] args) throws AWTException, InterruptedException, MalformedURLException, RemoteException, NotBoundException {
		if(args.length!=1)
		{
			System.err.println("erreur parametres [ip_serveur:port]");
			System.exit(0);
		}
		//on recupere la classe rmi
		System.out.println("connexion a "+args[0] );
		Iscore score = (Iscore) Naming.lookup("rmi://"+args[0]+"/Score");
		
		ArrayList<String > list = score.getList();
		String[] table;
		for(String s : list)
		{
			table = s.split(":");
			System.out.println(table[0].trim()+"  :  "+table[1]);
		}
	}
	
}
